/*
 * The Rubik's cube.
 *
 * Sed - april 1999.
 *
 * This program is in the public domain.
 *--------------------
 * The screen stuff, ie X.
 */

#ifndef _SCREEN_H_
#define _SCREEN_H_

#include <X11/Xlib.h>

typedef struct {
  char *buffer; //[SCREEN_X*SCREEN_Y];
  Display *d;
  Window w;
  Window h;
  XFontStruct *font;
  GC gc;
  Colormap cm;
  XImage *im;
  int pause;
  int depth;
} SCREEN;

#include "cube.h"

int init_screen(SCREEN *);
int screen_event(SCREEN *, CUBE *);
void close_screen(SCREEN *);
void clear_screen(SCREEN *);
void put_screen(SCREEN *);
void place_mouse(SCREEN *);
void grab_pointer(SCREEN *, int);
void set_cube_size();
struct timeval get_time(void);
int to16(int);
int to32(int);

#endif /* _SCREEN_H_ */
